=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'uri'

module WeFitter
  class TokenApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Token
    #  In order to create a token, perform a POST request to this endpoint, example:<br/> <table><tbody>     <tr><td>Application ID</td><td>123</td></tr>     <tr><td>Application Secret</td><td>ABC</td></tr>     <tr><td>Authorization header format</td><td>Authorization: base64(app_id:app_secret)</td></tr>     <tr><td>Expected result</td><td>Authorization: MTIzOkFCQw==</td></tr> </tbody></table> For testing purposes, a CURL can be used: <pre> curl -X POST -H \"Authorization: Basic MTIzOkFCQw==\" https://api.wefitter.com/api/v1.3/token/ # alternatively curl -X POST --user 123:ABC https://api.wefitter.com/api/v1.3/token/ </pre>  The response to a successful request should look like this: <pre> {     \"bearer\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJleHAiOiIxNTY2NTYxMzk2IiwiaWF0IjoxNTE2MjM5MDIyfQ.14x12h5VMJjAV2kFB5cCrfFmZhryBAYGk9N-vhyDl00\" } </pre> 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Token]
    def token_create(data, opts = {})
      data, _status_code, _headers = token_create_with_http_info(data, opts)
      data
    end

    # Create Token
    #  In order to create a token, perform a POST request to this endpoint, example:&lt;br/&gt; &lt;table&gt;&lt;tbody&gt;     &lt;tr&gt;&lt;td&gt;Application ID&lt;/td&gt;&lt;td&gt;123&lt;/td&gt;&lt;/tr&gt;     &lt;tr&gt;&lt;td&gt;Application Secret&lt;/td&gt;&lt;td&gt;ABC&lt;/td&gt;&lt;/tr&gt;     &lt;tr&gt;&lt;td&gt;Authorization header format&lt;/td&gt;&lt;td&gt;Authorization: base64(app_id:app_secret)&lt;/td&gt;&lt;/tr&gt;     &lt;tr&gt;&lt;td&gt;Expected result&lt;/td&gt;&lt;td&gt;Authorization: MTIzOkFCQw&#x3D;&#x3D;&lt;/td&gt;&lt;/tr&gt; &lt;/tbody&gt;&lt;/table&gt; For testing purposes, a CURL can be used: &lt;pre&gt; curl -X POST -H \&quot;Authorization: Basic MTIzOkFCQw&#x3D;&#x3D;\&quot; https://api.wefitter.com/api/v1.3/token/ # alternatively curl -X POST --user 123:ABC https://api.wefitter.com/api/v1.3/token/ &lt;/pre&gt;  The response to a successful request should look like this: &lt;pre&gt; {     \&quot;bearer\&quot;: \&quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJleHAiOiIxNTY2NTYxMzk2IiwiaWF0IjoxNTE2MjM5MDIyfQ.14x12h5VMJjAV2kFB5cCrfFmZhryBAYGk9N-vhyDl00\&quot; } &lt;/pre&gt; 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Token, Fixnum, Hash)>] Token data, response status code and response headers
    def token_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TokenApi.token_create ...'
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TokenApi.token_create"
      end
      # resource path
      local_var_path = '/token/'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Token')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TokenApi#token_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
